<?php
  require("includes/common.php");

  $q = (isset($_GET["q"])?tapestry_normalise($_GET["q"],":\."):"");

  $rewrite = isset($_GET["rewrite"]);

  if (isset($_POST["submit"]))
  {
    if (!isset($_POST["comments"])) $_POST["comments"] = "";

    if ($_POST["rating"] && ($_POST["rating"] == $_POST["confirm"]))
    {
      $sql = "INSERT INTO `".$config_databaseTablePrefix."reviews` SET created='".time()."',approved='0',product_name='".database_safe($q)."',rating='".database_safe($_POST["rating"])."',comments='".database_safe(stripslashes(trim($_POST["comments"])))."'";

      database_queryModify($sql,$insertId);
    }

    if ($config_useRewrite)
    {
      header("Location: ".$_SERVER["REQUEST_URI"]."?pending=1");
    }
    else
    {
      header("Location: ".$_SERVER["REQUEST_URI"]."&pending=1");
    }

    exit();
  }

  if ($q)
  {
    $banner["h2"] = translate("Price search results for")." <strong>".htmlentities($q,ENT_QUOTES,$config_charset)."</strong>&nbsp;";

    $sql = "SELECT * FROM `".$config_databaseTablePrefix."products` WHERE name = '".database_safe($q)."' ORDER BY price LIMIT ".$config_resultsPerPage;

    $numRows = database_querySelect($sql,$rows);

    if ($numRows)
    {
      foreach($rows as $k => $row)
      {
        if ($config_useRewrite)
        {
          $rows[$k]["merchantHREF"] = "../merchant/".tapestry_hyphenate($row["merchant"])."/";

          $rows[$k]["reviewHREF"] = "../review/".tapestry_hyphenate($row["name"]).".html";
        }
        else
        {
          $rows[$k]["merchantHREF"] = "search.php?q=merchant:".urlencode($row["merchant"]).":";

          $rows[$k]["reviewHREF"] = "reviews.php?q=".urlencode($row["name"]);
        }

        if ($config_useInteraction)
        {
          if ($rows[$k]["reviews"])
          {
            $rows[$k]["extraHTML"] = "<p>".tapestry_stars($rows[$k]["rating"],"")."&nbsp;<a href='".$rows[$k]["reviewHREF"]."'>".$rows[$k]["reviews"]." ".translate("Reviews")."</a></p>";
          }
          else
          {
            $rows[$k]["extraHTML"] = "<p><a href='".$rows[$k]["reviewHREF"]."'>".translate("Review This Product")."</a></p>";
          }
        }
      }

      $product["products"] = $rows;

      $prices["products"] = $rows;

      $sql = "SELECT * FROM `".$config_databaseTablePrefix."reviews` WHERE product_name = '".database_safe($q)."' AND approved <> '0' ORDER BY created";

      if (database_querySelect($sql,$rows))
      {
        $ratings["reviews"] = $rows;
      }

      $header["title"] = htmlentities($q,ENT_QUOTES,$config_charset);

      $header["meta"]["description"] = translate("Price search results for")." ".htmlentities($q,ENT_QUOTES,$config_charset);

      $header["meta"]["keywords"] = htmlentities($q,ENT_QUOTES,$config_charset);
    }
    else
    {
      $banner["h2"] .= "(".translate("product not found").")";
    }
  }

  if ($config_useRelated || (!isset($product)))
  {
    $where = "";

    if (isset($product))
    {
      if ($product["products"][0]["category"])
      {
        $where .= "category = '".database_safe($product["products"][0]["category"])."' AND ";
      }
    }
    $where .= "MATCH name AGAINST ('".database_safe($q)."') AND name <> '".database_safe($product["products"][0]["name"])."'";

    $sql = "SELECT * , MIN( price ) AS minPrice, MAX( price ) AS maxPrice, COUNT( id ) AS numMerchants, MATCH name AGAINST ('".database_safe($q)."') AS relevance FROM `".$config_databaseTablePrefix."products` WHERE ".$where." GROUP BY name ORDER BY relevance DESC LIMIT 3";

    $searchresults["numRows"] = database_querySelect($sql,$rows);

    $searchresults["products"] = $rows;

    if ($searchresults["numRows"])
    {
      foreach($searchresults["products"] as $k => $related)
      {
        if ($config_useRewrite)
        {
          $searchresults["products"][$k]["productHREF"] = "product/".tapestry_hyphenate($related["name"]).".html";

          if ($rewrite) $searchresults["products"][$k]["productHREF"] = "../".$searchresults["products"][$k]["productHREF"];
        }
        else
        {
          $searchresults["products"][$k]["productHREF"] = "products.php?q=".urlencode($related["name"]);
        }
      }

      $related = true;
    }
  }

  require("html/header.php");

  require("html/menu.php");

  require("html/searchform.php");

  require("html/banner.php");

  if (isset($product)) require("html/product.php");

  if (isset($prices)) require("html/prices.php");

  if (isset($related)) require("html/related.php");

  require("html/ratings.php");

  require("html/footer.php");
?>
